{
#include <iomanip.h>
	
 Int_t run[]  = {1107, 1109, 1110, 1111, 1112, 
  		1113, 1114, 1115, 1116, 1118, 
  		1119, 1120, 1121, 1122, 1123, 
  		1124, 1125, 1126, 1130, 1131, 
  		1132, 1133, 1134, 1135, 1136, 
  		1137, 1138, 1139, 1140, 1141, 
  		1142, 1143, 1144, 1145, 1146,
  		1147, 1148, 1149, 1150, 
  		1152, 1153  };
 Int_t type[] = {0,    3,    0,    3,    0, 	// {0, 1, 2, 3} =
 		2,    0,    1,    0,    2,	// {1GeV pi, pi, p, e}
 		2,    0,    1,    0,    3, 
 		0,    0,    2,    0,    1, 
 		0,    1,    0,    1,    0, 
 		2,    0,    0,    2,    0,
 		2,    0,    2,    0,    0, 
 		3,    0,    0,    3,    
 		0,    3 };
 		
 Double_t m[] = {0.13957, 0.13957, 0.93827, 0.000511 };
 		
 Double_t p[] = {1.0,  1.0,  1.0,  1.0,  1.0, 
 		1.0,  1.0,  0.5,  1.0,  0.6,
 		0.6,  1.0,  0.6,  1.0,  0.6, 
 		1.0,  1.0,  0.8,  1.0,  0.7,
 		1.0,  1.4,  1.0,  2.0,  1.0, 
 		1.4,  1.0,  1.0,  1.4,  1.0, 
 		2.0,  1.0,  2.0,  1.0,  1.0, 
 		0.8,  1.0,  1.0,  0.8,
 		1.0,  0.6  };		
  		
 Double_t T[] = {19.18, 19.22, 19.37, 19.325, 19.35,
 		19.15, 19.10, 18.90, 18.80, 18.75,
 		18.60, 18.60, 18.50, 18.50, 18.40,
 		18.33, 18.10, 18.08, 17.70, 17.68,
 		17.60, 17.73, 17.80, 18.125, 18.50,
 		18.70, 18.95, 19.65, 19.77, 19.75,
 		19.63, 19.55, 19.50, 19.40, 19.37,
 		19.25, 19.20, 19.13, 19.08,
 		18.90, 18.68  };
 		
 Double_t P[] = {763.5, 763.0, 763.0, 763.0, 763.0, 
 		763.5, 764.0, 764.0, 764.0, 764.0,
 		764.0, 764.0, 764.0, 764.0, 763.5,
 		763.0, 762.5, 762.0, 762.0, 761.0, 
 		761.5, 761.25, 761.0, 761.0, 761.0, 
 		760.6, 760.0, 758.0, 757.7, 757.5,
 		757.3, 757.0, 757.0, 757.5, 758.0, 
 		758.0, 758.0, 758.0, 757.0,
 		757.0, 757.0 }; 
	
 Int_t n = sizeof(run)/sizeof(Int_t);
 
 Double_t * mu  = new Double_t[n];
 Double_t * dmu = new Double_t[n];
 Double_t * bg  = new Double_t[n];
 Double_t * dbg = new Double_t[n];
 Double_t * pt  = new Double_t[n];
 
 Int_t ncalib = 0;
 Char_t fname[64];
  
 for (Int_t i = 0; i < n ; i++) {
   
   if (type[i] != 0) continue;
//   cerr << "ncalib: " <<ncalib<< endl; 	
   
   sprintf(fname,"jsf%4.4dfixedwidth_varped.root",run[i]);
   TFile file(fname);
   file.cd("/");
   Double_t nent = Trunc->GetEntries();
   Double_t rms  = Trunc->GetRMS();
   mu[ncalib]    = Trunc->GetMean();   
   bg[ncalib]    = p[i]/m[type[i]];
   pt[ncalib]    = P[i]/(T[i] + 273.15);
//   pt[ncalib]    = (T[i] + 273.15) / P[i];
   dmu[ncalib]   = rms / sqrt(nent); 
   dbg[ncalib]   = 0.;
   
#if 0   
   cerr 
//        << "run, nent, mean, rms, T, P, bg: " 
        << setiosflags(ios::fixed)
        << setw(5) << run[i] 
        << setw(3) << type[i]
        << setw(5) << setprecision(1) << p[i]
        << setw(6) << setprecision(0) << nent 
        << setw(8) << setprecision(1) << mu[ncalib] 
        << setw(8) << setprecision(1) << rms 
        << setw(8) << setprecision(2) << T[i]+273.15 
        << setw(9) << setprecision(2) << P[i] 
        << setw(12)<< setprecision(2) << bg[ncalib] << endl;
#endif       
        
   ncalib++;    
 } 
 c1 = new TCanvas("c1", "calib", 20, 20, 800, 600);
 gStyle->SetOptStat(1);
 gStyle->SetOptFit(1);
 grcalib = new TGraphErrors(ncalib, pt , mu, dbg, dmu);
 grcalib->SetMarkerColor(4);
 grcalib->SetMarkerStyle(21);
 grcalib->Draw("AP");
 grcalib->Fit("pol1");
 grcalib->SetName("calib");
 grcalib->SetTitle("Gain Calibration");
 grcalib->GetHistogram()->SetXTitle("P/T(mmHg/K)");
 grcalib->GetHistogram()->SetYTitle("Charge");
 tex = new TLatex(2.586,2120.,"UseVarPed");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 tex = new TLatex(2.586,2100.,"1GeV #pi^{+}");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 tex = new TLatex(2.586,2080.,"Width fixed at 100 t-slots");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 c1->Modified();
 Double_t p0 = grcalib->GetFunction("pol1")->GetParameter(0);
 Double_t p1 = grcalib->GetFunction("pol1")->GetParameter(1);
 
 Double_t norm = p0 + p1 * ( 760.0/ 293.15 );	// at 20degreesC  1atm.
 p0 /= norm;
 p1 /= norm;
 
 Double_t ref;    
 for (Int_t i=0; i<n; i++) {
   
   sprintf(fname,"jsf%4.4dfixedwidth_varped.root",run[i]);
   TFile file(fname);
   file.cd("/");
   Double_t nent = Trunc->GetEntries();
   Double_t rms  = Trunc->GetRMS();
   mu[i]    = Trunc->GetMean();   
   bg[i]    = p[i]/m[type[i]];
   pt[i]    = P[i]/(T[i] + 273.15);
   dmu[i]   = rms / sqrt(nent); 
   dbg[i]   = 0.;
   	
     
#if 1     
   cerr 
//        << "run, nent, mean, rms, T, P, bg: " 
        << setiosflags(ios::fixed)
        << setw(5) << run[i] 
        << setw(3) << type[i]
        << setw(5) << setprecision(1) << p[i]
        << setw(6) << setprecision(0) << nent 
        << setw(8) << setprecision(1) << mu[i] 
        << setw(8) << setprecision(1) << rms 
        << setw(8) << setprecision(2) << T[i]+273.15 
        << setw(9) << setprecision(2) << P[i] 
        << setw(9) << setprecision(2) << bg[i] << endl;
#endif

   if (p[i] == 0.7 && type[i] == 1) ref = mu[i];
   
 }
#if 1 
 c2 = new TCanvas("c2", "dE/dX(Before Temp. correct)", 40, 40, 800, 600);
 c2->SetLogx();
 gr = new TGraphErrors(n, bg , mu, dbg, dmu);
 gr->SetMarkerColor(4);
 gr->SetMarkerStyle(2);
 gr->Draw("AP");
 gr->SetName("dedx");
 gr->SetTitle("dE/dX(before Temp. correct)");
 gr->GetHistogram()->SetXTitle("#beta#gamma");
 gr->GetHistogram()->SetYTitle("<dE/dX>");
 tex = new TLatex(1.13717,2.18396,"UseVarPed");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 tex = new TLatex(1.13052,2.09711,"Width fixed at 100 t-slots");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 c2->Modified();
#endif 
 
 for (Int_t i=0; i<n; i++) {
 	
#if 1   
   mu [i] /= p0 + p1*pt[i];
   dmu[i] /= p0 + p1*pt[i];
#endif
   mu[i]  /= ref;
   dmu[i] /= ref;
   
 }
 c3 = new TCanvas("c3", "dE/dX (normalized) ", 60, 60, 800, 600);
 c3->SetLogx();
 gr2 = new TGraphErrors(n, bg , mu, dbg, dmu);
 gr2->SetMarkerColor(4);
 gr2->SetMarkerStyle(2);
 gr2->Draw("AP");
 gr2->SetName("ndedx");
 gr2->SetTitle("Normalized dE/dX");
 gr2->GetHistogram()->SetXTitle("#beta#gamma");
 gr2->GetHistogram()->SetYTitle("<dE/dX>/<dE/dX>_{min}");
 tex = new TLatex(1.13717,2.18396,"UseVarPed");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 tex = new TLatex(1.13052,2.09711,"Width fixed at 100 t-slots");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 tex = new TLatex(1.14383,2.01027,"Normalized by 0.7GeV #pi^{+}");
 tex->SetTextSize(0.05);
 tex->SetLineWidth(2);
 tex->Draw();
 c3->Modified();
  
} 
   
